#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string.h>
using namespace std;
int main () {
	{
	int *p; // Betyder att p r pekare till int
	int k=19;
	p = &k; // Nu har k ftt ett namn till (*p)
	*p = 17; // ndrar ven k till 17
	}

	{
	int *p1, *p2;
	int n=4, m=5;
	p1 = &n; // p1 pekar p n
	p2 = &m; // p2 pekar p m
	*p1 = 7; // n blir 7
	*p2 = *p1; // m blir ocks 7
	p2 = p1; // p2 pekar p n
	}

	{
	int k; // ndringsbar int
	const int c = 100;// konstant int
	const int *pc; // pekare till konstant int
	int *pi; // pekare till ndringsbar int
	pc = &c; // OK
	pc = &k; // OK, men k kan inte ndras via *pc
//	pi = &c; // FEL! pi fr ej peka p en konstant
//	*pc = 0; // FEL! pc pekar p en konstant
	int *const cp = &k; // Konstant pekare
//	cp = 0; // FEL! Pekaren ej flyttbar
	*cp = 123; // OK! ndrar k till 123
	}

	{
	int n=7, m, *p;
	int& r1 = n; // r1 r en referens till n
	r1 = 7;      // n fr vrdet 7
	int& r2 = m; // Referenser mste initieras
	r2 = r1;     // m fr vrdet 7
	p = &r1;     // p pekar p n
	*p = 4;      // n fr vrdet 4
	r2 = *p + 1; // m fr vrdet 5
	}

	{
	float f[4]; // 4 st float
	float *pf; // pekare till float
	pf = f; // samma som pf = &f[0]
	float x = *(pf+3); // Alt. x = pf[3];
	x = pf[3];         // Alt. x = *(pf+3);
	}

	{
	float f[4]; // 4 st float
	// Alt. 1
	for (int i=0; i<4; i++)
		f[i] = 0;
	// Alt. 2
	for (float *p=f; p<f+4; p++)
		*p = 0;
	// Alt. 3 (C++11)
	for (float &e : f)
		e = 0;
	}

	{
	char namn[] = "Nisse";
	char *p;
	p = namn;
	cout << p << endl;
	cout << p+3 << endl;    // Skriver en delstrng
	cout << *(p+3) << endl; // Skriver en char
	cin >> ws;
	}

	{
	double *pd = new double;
	*pd = 3.141592654;
	float *px, *py;
	px = new float[20];
	py = new float[20];

	delete pd;
	delete [] px; // [] krvs fr flt
	delete [] py;
	}

	{
	char namn[80];
	char *p;     //Ingen varning vid kompilering
//	char *p = NULL;     //Ingen varning vid kompilering
//	char str[];  // Kompileringsfel med Gnu!
	*namn = 'Z'; // Ok. Ger namn[0]='Z'
//	*p = 'Z';    // Fel! 'Z' hamnar i icke
	             // allokerat utrymme(krasch)
	 strcpy(p, "Nisse Nilsson");
	// Ger garanterat exekveringsfel
	// ("Segmentation fault" i Linux)
	}

}

void zero(int *x, int n) {
	for (int *p=x; p < x+n; p++)
		*p= 0;
}

// Anvndning av const char* fr
// att garanterat inte ndra ngot
int strleng(const char *s) {
   const char *p; // Pekaren kan ndras!
   for (p = s; *p++; )
      ;
   return p-s-1;
}
