#include <iostream>
using namespace std;

char* wdays[] = {"mndag", "tisdag", "onsdag",
         "torsdag", "fredag", "lrdag", "sndag"};
int main(int argc, char* argv[]) {
   int y, m, d, ind;
   if (argc!=4) {
      cout <<"Anropa enligt mnstret " << argv[0]
           << "yyyy mm dd" << endl;
      return -1;
   }
   y=atoi(argv[1]); m=atoi(argv[2]); d=atoi(argv[3]);
   if (m<3) {m+=12; y--;} // Zeller's kongruens (1886)!
   ind = (d + 2*m + (3*(m+1))/5
         + y + y/4 - y/100 + y/400) % 7;
   cout << argv[1] << "-" << argv[2] << "-"
        << argv[3] << " r en " << wdays[ind] << endl;
} // Datumformat enligt standarden ISO8601
